unit csvEdit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, shellapi,ExtCtrls, Grids, StdCtrls, PDJRotoLabel, ComCtrls,mledit,
  CustomOpenDialog;

type
    savetype = (adresstype,emailtype,telefontype,alletype,foxmailtype);
    savetypea = array[savetype] of string;

    charfiletype = file of char;
    zwecktyp = (conf,edit);
    TForm1 = class(TForm)

    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Boeffnen: TButton;
    Bspeichern: TButton;
    Bexit: TButton;
    ConfigB: TButton;
    FelderLB: TListBox;
    SaveDialog2: TSaveDialog;
    Panel1: TPanel;
    UpDown1: TUpDown;
    DatenSG: TStringGrid;
    suchE: TEdit;
    LSuch: TLabel;
    LHinweis: TLabel;
    BMaske: TButton;
    BSortierFeld: TButton;
    tempLB: TListBox;
    BAusgabeDatei: TButton;
    SpeicherortDialog: TCustomSaveDialog;
    Lspeichere: TLabel;
    Beinsortieren: TButton;
    EFeldName: TEdit;
    MaskenFelderLB: TListBox;
    AusgabeDateiSG: TStringGrid;
    Panel2: TPanel;
    AusDatSG: TStringGrid;
    LAusDatHeader: TLabel;
    LAusDatSave: TLabel;
    LAusDatS: TLabel;
    LAusDatL: TLabel;
    BAusDatOk: TButton;
    BAusDatesc: TButton;
    AusDatSSG: TStringGrid;
    AusDatLsg: TStringGrid;
    OpenDialog2: TOpenDialog;
    dummyPM: TPopupMenu;
    einleseLB: TListBox;
    LNeuersatz: TLabel;
    procedure leeren;
    procedure FormCreate(Sender: TObject);
    procedure openClick(Sender: TObject);
    procedure exit1Click(Sender: TObject);
    procedure speichern1Click(Sender: TObject);
    procedure writestr(var f : charfiletype; s : string);
    function zerlege(s : string; sg : tstringgrid; reihe : integer) : integer;
    procedure startparameter;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ConfigBClick(Sender: TObject);
    function zerlegestring(s : string; lb : tlistbox) : integer;
    procedure createFeld(nr,x,y,w,h,farbe : integer; beschr,hnt : string; zweck : zwecktyp);
    procedure Edit1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure maskespeichern;
    procedure aufrufen(satz : integer);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure eingabemodus;
    procedure feldermachen(zweck : zwecktyp);
    procedure configmodus;
    procedure felderweg;
    procedure suchEChange(Sender: TObject);
    procedure suchEKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure suchEEnter(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure neuersatz;
    function neuessuchfeld(sf : integer; machen : boolean) : boolean;
    procedure satzloeschen;
    procedure variablesetzen;
    procedure Edit1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure ausgeben1Click(Sender: TObject);
    procedure dateilesen;
    procedure dateizeigen;
    procedure DatenSGClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1DblClick(Sender: TObject);
    function neuesmussfeld(mf : integer; machen : boolean) : boolean;
    procedure BMaskeClick(Sender: TObject);
    procedure Maske1Click(Sender: TObject);
    procedure SortStringGrid(var GenStrGrid: TStringGrid; ThatCol: Integer);
    procedure neuessortierfeld(feld : tmledit);
    function mussfeldtest(aktuell : integer) : boolean;
    procedure BSortierFeldClick(Sender: TObject);
    procedure BsortClick(Sender: TObject);
    procedure BAusgabeDateiClick(Sender: TObject);
    procedure PopupMenu2Popup(Sender: TObject);
    procedure BeinsortierenClick(Sender: TObject);
    function linksoben : twincontrol;
    procedure Label1Click(Sender: TObject);
    procedure EFeldNameKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure BAusDatOkClick(Sender: TObject);
    procedure AusgabeDateiSGDblClick(Sender: TObject);
    procedure BAusDatescClick(Sender: TObject);
    procedure AusDatSSGClick(Sender: TObject);
    procedure AusDatLsgClick(Sender: TObject);
    procedure originaldateischreiben;
    procedure teildateischreiben(st : savetype);
    procedure foxfelder;
    procedure write_foxmail_addressbook(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const
     capt = 'CSV Edit   TH0.9   ';
     mfnc : string = 'csvedit.msk';
     raster: integer = 10;
     savetypnamen : savetypea = ('ADRESSEN-DATEI','EMAIL-DATEI','TELEFON-DATEI','USER-DATEI','FOXMAIL-DATEI');
var

  Form1: TForm1;
  aktlabel : tlabel;
  sortierfeld: tmledit;
  mfn,startdir,fn,s,ss : string;
  tabord,grenze,NmaxSpalte,NmaxReihe,richtung,suchstart,maxmussfelder,maxsuchfelder,satz,xpos,ypos,aktuell,spalte,reihe,NmaxFelder,NSpeicherFelder,max,p,n : integer;
  f : text;
  f_out,f_out_teil : charfiletype;
  volltext,aenderung, aenderung_maske,geloescht,spC,openfilenameok,SAVEfilenameok, fertig : boolean;
  l : longint;
  cr,lf : char;
  labelarray : array[0..50] of tlabel;
//  maskenfeldarray : array[0..50] of string;
  editarray : array[0..50] of tmledit;
  suchfelda : array[0..50] of integer;
  mussfelda : array[0..50] of integer;
   h : hwnd;
  auto_name,foxmail,neuersatz_flag, doubleclicked, chsize_en : boolean;
  savetyp : savetype;
  savenamen : savetypea;
  zweck : zwecktyp;
  maxtop,email_feld,nachname_feld,vorname_feld,name_feld : integer;

implementation
{$R *.DFM}

procedure tForm1.foxfelder;
var n : integer;
begin
for n:= 0 to NMaxFelder do begin
    s:= felderLB.items[n];
    if s = 'Vorname' then vorname_feld:= n;
    if s = 'Nachname' then nachname_feld:= n;
    if s = 'Name' then name_feld:= n;
    if s = 'eMail Adresse' then email_feld:= n;
end;
end;

procedure tForm1.dateilesen;
begin
fn:= opendialog1.filename;
//form1.caption:= capt+fn+' =>  '+savetypnamen[savetyp];
assignfile(f,fn);
{$i-}reset(f);{$i+}
if ioresult = 0 then begin
   readln(f,s);
   NmaxFelder:= zerlegestring(s, felderLB);
   maskenfelderlb.items:= felderlb.items;
   {Stze lesen}
   datensg.ColCount:= NmaxFelder+1;
   while not eof(f) do begin
      readln(f,s);
      zerlege(s,datenSG,reihe);
      inc(reihe); inc(aktuell);
   end;
   dec(reihe);
   NmaxReihe:= reihe;
   CloseFile(F);
   foxfelder;
end;
end;

procedure TForm1.dateizeigen;
begin
   eingabemodus;
   feldermachen(edit);
   aufrufen(0);
   form1.visible:= true;
   aenderung:= false;
   aenderung_maske:= false;
   activecontrol:= suche;
end;

procedure tform1.startparameter;
var ss,fn : string;
    a : savetype;
    n,pc,p1,p2 : integer;

          function isoliere(s : string) : string;
          begin
          s:= copy(s,pos('=',s)+1,255);
          while (s<>'')and (s[1] = ' ') do delete(s,1,1);
          result:= s;
          end;
begin
// Dateinamen
fn:= '';
startdir:= extractfilepath(paramstr(0));
mfnc:= startdir+mfnc;
assignfile(f,startdir+'csvedit.ini');
{$i-}reset(f);{$i+}
if ioresult = 0 then begin
   while not eof(f) do begin
      readln(f,s);
      delete(s,pos('#',s),255);
      if pos('OPENFILENAME',uppercase(s)) > 0 then opendialog1.FileName:= isoliere(s);
      if pos('SAVEFILENAME',uppercase(s)) > 0 then savedialog1.FileName:= isoliere(s);
      if pos('MASKFILENAME',uppercase(s)) > 0 then mfn:= isoliere(s);
      for a:= adresstype to foxmailtype do
          if pos(savetypnamen[a], uppercase(s)) > 0 then begin
             templb.clear;
             zerlegestring(isoliere(s),tempLB);
             savenamen[a]:= templb.Items[0];
             if templb.Items.Count > 1 then     // Datei immer speichern?
                if templb.items[1] = '1' then ausdatSsg.cells[0,integer(a)]:= 'x' else ausdatSsg.cells[0,integer(a)]:= '';
             if templb.Items.Count > 2 then     // mit Header speichern?
                if templb.items[2] = '1' then ausdatLsg.cells[0,integer(a)]:= 'x';
          end;
   end;
   closefile(f);
end;

pc:= paramcount;
s:= '';
for n:= 1 to pc do s:= s + paramstr(n) + ' '; s:= uppercase(s);
if length(s) > 3 then begin
   p1:= pos ('/O',s); // openfile?
   if p1 > 0 then begin
      ss:= copy(s,p1+3,255);
      p2:= pos(' /',ss);
      if p2 > 0 then ss:= copy(ss,1,p2-1) else p2:= 255;
      if fileexists(ss) then opendialog1.FileName:= ss;
      delete(s,p1,p2+3);
   end;
   p1:= pos ('/S',s); // savefile?
   if p1 > 0 then begin
      ss:= copy(s,p1+3,255);
      p2:= pos(' /',ss);
      if p2 > 0 then ss:= copy(ss,1,p2-1) else p2:= 255;
      if fileexists(ss) then savedialog1.FileName:= ss;
      delete(s,p1,p2+3);
   end;

   p1:= pos ('/M',s); // mask-definition-file?
   if p1 > 0 then begin
      ss:= copy(s,p1+3,255);
      p2:= pos(' /',ss);
      if p2 > 0 then ss:= copy(ss,1,p2-1) else p2:= 255;
      if fileexists(ss) then mfn:= ss;
      delete(s,p1,p2+3);
   end;
   p1:= pos ('/F',s); // Foxmail-Automatik?
   if p1 > 0 then begin
      ss:= copy(s,p1+2,255);
      p2:= pos(' /',ss);
      if p2 > 0 then ss:= copy(ss,1,p2-1) else p2:= 255;
      foxmail:= true;
      delete(s,p1,p2+2);
   end;
   p1:= pos ('/V',s); // Volltext-Suche?
   if p1 > 0 then begin
      ss:= copy(s,p1+2,255);
      p2:= pos(' /',ss);
      if p2 > 0 then ss:= copy(ss,1,p2-1) else p2:= 255;
      volltext:= true;
      delete(s,p1,p2+2);
   end;

   p1:= pos ('/',s); // StartMaske?
   if p1 > 0 then begin
      s:= copy(s,2,4);
      for a:= adresstype to alletype do
      if pos(s,savetypnamen[a]) > 0 then savetyp:= a;
   end;
end;
if mfn = '' then mfn:= mfnc;
opendialog2.InitialDir := extractfilepath(mfn);
end; // startparameter

procedure tform1.variablesetzen;
var x : savetype;
begin
for x:= adresstype to alletype do savenamen[x]:= savetypnamen[x]+'.csv';
savenamen[foxmailtype]:= 'address.box';
panel2.visible:= false;
geloescht:= false;
grenze:= 500;
richtung:= 1;
satz:= 0;
//height:=703;
width:= 600;
top:= 0;
left:= screen.width -width;
cr:= #13; lf:= #10;
form1.caption:= capt;
chsize_en:= false;
xpos:= 20;
ypos:= 60;
form1.height:= panel1.top + 25;
application.hintpause:= 10;
application.HintHidePause:= 20000;
savetyp:= alletype;
Reihe:= 0;
zweck:= edit;

Lhinweis.hint:= 'Felder mit der Maus auf die gewnschte Stelle ziehen - nicht gewnschte Felder auf der Mllflche unten ablegen'+#13+
                'zum ndern der Feldgre eine Taste drcken und mit der Maus ziehen'+#13+
                'ein Rechtsklick macht ein Feld zu einem Suchfeld';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
variablesetzen;
startparameter;
if fileexists(opendialog1.filename) then begin
   dateilesen;
   dateizeigen;
end;
end;

procedure tform1.leeren;
var n : integer;
begin
for n := 0 to NmaxReihe do DatenSG.Rows[n].Clear;
felderweg;
end;

procedure TForm1.openClick(Sender: TObject);
begin
if opendialog1.Execute then begin
   form1.visible:= false;
   leeren;
   variablesetzen;
   dateilesen;
   dateizeigen;
end;
activecontrol:= SuchE;
end;  {openclick}

procedure tform1.aufrufen(satz : integer);
var n : integer;
begin
if geloescht then begin
  geloescht:= false;
  for n:= 0 to nmaxfelder do
      editarray[n].color:= clwhite;
  for n:= 0 to maxmussfelder do
      editarray[mussfelda[n]].color:= $0080FFFF;
end;
for n:= 0 to nmaxfelder do begin
  editarray[n].text:= datenSG.cells[n,satz];
end;
updown1.Position := satz;
updown1.Max := Nmaxreihe;
if neuersatz_flag then begin
   beinsortieren.visible:= true;
   neuersatz_flag:= false;
   beep;
   lneuersatz.visible:= true;
end
else begin
     beinsortieren.visible:= false;
     lneuersatz.visible:= false;
end;
auto_name:= false;
end; // aufrufen

procedure TForm1.exit1Click(Sender: TObject);
begin
if (not (aenderung or aenderung_maske)) or
   (Messagedlgpos('exit ohne speichern?',mtConfirmation,[mbyes,mbno], 0,form1.left+bmaske.Left ,80) = mryes)
   then form1.close;
end;

procedure tform1.writestr(var f: charfiletype; s: string);
var
   n,max : integer;
begin
max:= length(s);
for n:= 1 to max do write(f,s[n]);
end;

function tform1.zerlege(s : string; sg : tstringgrid; reihe : integer): integer;
var spalte,p : integer;
    hilfstr,ss : string;
begin
   spalte:= 0;
   sg.rowCount := reihe+1;
   repeat
      {test auf Aufzhlungsfelder: "ccc,ddd"}
      if (s <> '') and (s[1] = '"') then begin
         delete(s,1,1);
         p:= pos('"',s);
         while p = 0 do begin
            inc(aktuell);
            readln(f,hilfstr);
            s:= s + cr+ lf + hilfstr;
            p:= pos('"',s);
         end;
//???         ss:= '"'+copy(s,1,p-1)+'"';
         ss:= copy(s,1,p-1);
         delete(s,1,p);
         p:= pos(',',s);
         if p <> 0 then delete(s,1,p);
      end
      else begin
         p:= pos(',',s);
         if p <> 0 then begin  {normaler Eintrag}
            ss:= copy(s,1,p-1);
            delete(s,1,p);
         end
         else ss:= s;  {RestString}
      end;
      while (ss<>'')and (ss[length(ss)] = ' ') do delete(ss,length(ss),1);
      sg.cells[spalte,reihe]:= ss;
      inc(spalte);
   until p = 0;
   result:= SG.RowCount-1;
end;


function tform1.zerlegestring(s : string; lb : tlistbox) : integer;
var n,p : integer;
   ss : string;
begin
   n:= 0;
   repeat
      p:= pos(',',s);
      if p <> 0 then begin  {normaler Eintrag}
         ss:= copy(s,1,p-1);
         delete(s,1,p);
      end
      else ss:= s;  {RestString}
      while (ss<>'')and (ss[length(ss)] = ' ') do delete(ss,length(ss),1);
      LB.items.add(ss);
      inc(n);
   until p = 0;
   result:= n-1;
end;

function tform1.mussfeldtest(aktuell : integer) : boolean;
var ss : string;
    nn : integer;
begin
for nn:= 0 to maxmussfelder do  {diesen Satz schreiben?}
    ss:= ss + DatenSG.cells[mussfelda[nn],aktuell];
result:= ss <> '';
end;

procedure tform1.originaldateischreiben;
var n : integer;
begin
AssignFile(F_out, SaveDialog1.FileName);	{ Ausgabedatei ffnen }
Rewrite(F_out);	{ Datensatzgre = 1 }
NSpeicherFelder:= 0;

{header schreiben}
for n:= 0 to NmaxFelder do begin
   writestr(f_out,FelderLB.items[n]+',');
end;
l:= filepos(f_out);
seek(f_out,l-1);
writestr(f_out,cr+lf);

{Stze schreiben}
aktuell:= 0;
while aktuell <= Nmaxreihe do begin
      s:= '';
      ss:= '';
      for n:= 0 to NmaxFelder do begin
          ss:= DatenSG.cells[n,aktuell];
          if pos(',',ss) + pos(#13,ss) > 0 then
             ss:= '"'+ss+'"';
          s:= s + ss + ',';
      end;
      delete(s,length(s),1);
      if s <> '' then
         if length(s) > NmaxFelder then // Test auf leere Stze !
            writestr(f_out,s+cr+lf);
      inc(aktuell);
end;
CloseFile(F_out);
end; // originaldateischreiben;

procedure tform1. teildateischreiben(st : savetype);
var     diesen : boolean;
        n      : integer;
begin
AssignFile(F_out_teil, savenamen[st]);
Rewrite(F_out_teil);
NSpeicherFelder:= 0;

if (ausdatLsg.cells[0,integer(st)]='x') then begin
   {header schreiben}
   for n:= 0 to NmaxFelder do begin
      if labelarray[n].top < grenze then
         writestr(f_out_teil,maskenfelderLB.items[n]+',');
   end;
   l:= filepos(f_out_teil);
   seek(f_out_teil,l-1);
   writestr(f_out_teil,cr+lf);
end;
{Stze schreiben}
aktuell:= 0;
while aktuell <= Nmaxreihe do begin
      s:= '';
      ss:= '';
      diesen:= mussfeldtest(aktuell);
      if diesen then begin
         for n:= 0 to NmaxFelder do begin
            if editarray[n].top < grenze then begin
               ss:= DatenSG.cells[n,aktuell];
               if pos(',',ss) + pos(#13,ss) > 0 then
                  ss:= '"'+ss+'"';
               s:= s + ss + ',';
            end; // if
         end; // for
         delete(s,length(s),1);
         if s <> '' then writestr(f_out_teil,s+cr+lf);
      end; // if diesen
      inc(aktuell);
end; // while
CloseFile(F_out_teil);
end; //teildateischreiben(st : savetype);


procedure TForm1.speichern1Click(Sender: TObject);
var
    aktsavetyp,st : savetype;
    andere_speichern : boolean;

begin
if zweck = edit then begin
   if savedialog1.filename = '' then
      savedialog1.execute;
   if savedialog1.filename <> '' then begin
      lspeichere.visible:= true;
      application.processmessages;

// zuerst die Original-Datei
      originaldateischreiben;
//    jetzt die Teil-Datei(en)
      aktsavetyp:= savetyp;
      andere_speichern:= false;
      for st:= adresstype to alletype do begin
          if (st <> aktsavetyp) and (ausdatSsg.cells[0,integer(st)]='x') then begin
             andere_speichern:= true;
             savetyp:= st;
             felderweg;
             feldermachen(zweck);
             teildateischreiben(savetyp);
          end;
      end;
      savetyp:= aktsavetyp;
      if andere_speichern then begin
         felderweg;
         feldermachen(zweck);
      end;
      teildateischreiben(savetyp);
      aenderung:= false;
      if ausdatSsg.cells[0,integer(foxmailtype)] = 'x' then write_foxmail_addressbook(sender);
      lspeichere.visible:= false;
   end;
   activecontrol:= SuchE;
end
else begin
   maskespeichern;
end;

end; // speichern1click


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
    a : savetype;
    s : string;
    c1,c2 : char;

begin
assignfile(f,startdir+'csvedit.ini');
rewrite(f);
writeln(f,'OPENFILENAME = '+ opendialog1.FileName);
writeln(f,'SAVEFILENAME = '+ savedialog1.filename);
writeln(f,'MASKFILENAME = '+ mfn);
for a:= adresstype to foxmailtype do begin
    if ausdatSsg.cells[0,integer(a)] = 'x' then c1:= '1' else c1:= '0';
    c2:= '0';
    if a < foxmailtype then
       if ausdatLsg.cells[0,integer(a)] = 'x' then c2:= '1' else c2:= '0';
    s:= ','+c1+','+c2;
    writeln(f,savetypnamen[a]+' = '+ savenamen[a]+s);
end;
closefile(f);
end;

procedure tform1.createFeld(nr,x,y,w,h,farbe : integer; beschr,hnt : string; zweck : zwecktyp);
begin
labelarray[nr]:= tlabel.create(form1);
with labelarray[nr] do begin
   caption:= beschr;
   left:= x;
   top:= y -15;
   tag:= nr;
   parent:= form1;
   if zweck = conf then onclick:= Label1Click;
end;
editarray[nr]:= tmledit.create(form1);
with editarray[nr] do begin
   left:= x;
   top:= y;
   width:= w;
   height:= h;
   hint:= hnt;
   tag:= nr;
   if top > grenze then begin
      tabstop:= false;
      text:= beschr;
      color:= clgray;
   end
   else begin
        color:= clwindow;
        if top+height > maxtop then maxtop:= top+height;
   end;
   autosize:= false;
   wordwrap:= true;
   multiline:= true;
   parent:= form1;
   popupmenu:= dummyPM;
   onKeyup:= Edit1Keyup;
   if zweck = conf then begin
      ondblclick:= Edit1DblClick;
      onmousedown:= Edit1MouseDown;
      onKeyDown:= Edit1KeyDown;
      onmousemove:= Edit1MouseMove;
   end
   else begin
//        onkeydown:= suchEKeyDown;
        onchange:= edit1change;
        onkeypress:= Edit1KeyPress;
   end;
end;
end;{createFeld}

procedure tform1.configmodus;
begin
configB.caption:= 'fertig';
Lsuch.visible:= false;
suchE.visible:= false;
Boeffnen.visible:= false;
form1.height:= 715;
panel1.visible:= true;
LHinweis.visible:= true;
bsortierfeld.visible:= true;
bausgabedatei.visible:= true;
BSpeichern.Caption:= 'Maske speichern';
BSpeichern.width:= 87;
BSpeichern.left:= 50;
end; // configmodus

procedure tform1.feldermachen(zweck : zwecktyp);
var maske_da,io,n,x,y,w,h,feld,sp,farbe,fp,fpe : integer;
    beschr,hnt : string;

    function positioniere_maske : integer;
    var xs : string;
        nMaxE,xx : integer;

    begin
    assignfile(f,mfn);
    {$i-}reset(f);{$i+}
    io:= ioresult;
    if io = 0 then begin
       xs:= savetypnamen[savetyp];
       einleseLB.Clear;
       while not eof(f) do begin
             readln(f,s);
             einleseLB.items.add(s);
       end;
       closefile(f);
       nMaxE:= einleseLB.items.count-1;
       fp:= 0;
       repeat
           s:= einleseLB.Items[fp];
           xx:= pos(xs,s);
           inc(fp);
       until (xx > 0) or (fp >= NMaxE);
       if xx = 0 then begin
          result:= -1;
          exit;
       end;
       fpe:= fp;
       repeat
           s:= einleseLB.Items[fpe];
           xx:= pos('-DATEI',s);
           inc(fpe);
       until (xx > 0) or (fpe >= NMaxE);
       if xx > 0 then dec(fpe,1); // else dec(fpe);
       xx:= fpe-fp;
       result:= xx;
       if (xx < NMaxFelder) and (zweck = edit) then begin
         s:= inttostr(NMaxfelder - xx);
         Messagedlgpos(s+' Feld(er) nicht in der Maske definiert!',mtInformation,[mbOk], 0,form1.left+bmaske.Left ,80);
       end;
    end else begin
        if zweck = edit then
           Messagedlgpos(mfn+' nicht gefunden.',mtInformation,[mbOk], 0,form1.left+bmaske.Left ,80);
        result:= -1;
        end;
    end;

begin
if zweck = edit then form1.caption:= capt+fn+' =>  '+savetypnamen[savetyp]
  else form1.caption:= capt + 'MASKEN-DEFINITION : ' + savetypnamen[savetyp];
maxtop:= 0;
maxsuchfelder:= -1;
maxmussfelder:= -1;
// Felder positionieren
if not fileexists(mfn) then
   if zweck = edit then
      if opendialog2.execute then mfn:= opendialog2.filename;

maske_da:= positioniere_maske;
sortierfeld:= nil;
for n:= 0 to NmaxFelder do begin
    beschr:= maskenFelderLB.items[n];
    if maske_da >= n then begin
       s:= einleseLB.items[n+fp];

       templb.Clear;
       zerlegestring(s,tempLB);
       feld:= strtoint(tempLB.items[0]);
       x:= strtoint(tempLB.items[1]);
       y:= strtoint(tempLB.items[2]);
       w:= strtoint(tempLB.items[3]);
       if tempLB.items[5] <> '' then hnt:= tempLB.items[5] else hnt:= '0';
       sp:= strtoint(hnt);
       if templB.items.count > 6  then
          if tempLB.items[6] <> '' then maskenfelderlb.items[n]:= tempLB.items[6];
       beschr:= maskenfelderlb.items[n];
       if tempLB.items[4] <> '' then h:= strtoint(tempLB.items[4]) else h:= 20;
    end
    else begin
       x:= xpos+ (n mod 5)*100;
       y:= ypos+ (n div 5) *50 ;
       w:= 70;
       h:= 20;
       hnt:= '0';
    end;
    createFeld(n,x,y,w,h,farbe,beschr,hnt,zweck);
    if maske_da >= n then begin
       if sp and 1 = 1 then neuessuchfeld(n,true);
       if sp and 2 = 2 then neuesmussfeld(n,true);
       if sp and 4 = 4 then begin
          sortierfeld:= editarray[n];
          neuessortierfeld(editarray[n]);
       end;
    end;
end;
tabord:= suchE.taborder+1;
if zweck = edit then form1.height:= maxtop + 50;
end; // feldermachen


procedure tform1.eingabemodus;
begin
configb.caption:= 'config';
form1.height:= panel1.top + 25;


panel1.Visible := false;
LHinweis.visible:= false;
bsortierfeld.visible:= false;
Lsuch.visible:= true;
suchE.visible:= true;
Boeffnen.visible:= true;
bausgabedatei.visible:= false;
BSpeichern.Caption:= 'speichern';
BSpeichern.width:= 57;
BSpeichern.left:= 80;
// form1.caption:=
end;

procedure tform1.felderweg;
var n : integer;
begin
for n:= 0 to nmaxfelder do begin
    editarray[n].free;
    labelarray[n].free;
end;
end;

procedure TForm1.ConfigBClick(Sender: TObject);
begin
if felderLB.Items.count = 0 then exit;
// umschalten auf editieren
if zweck = conf then begin
//if configB.caption = 'fertig' then begin
   zweck:= edit;
   if aenderung_maske then maskespeichern;
   felderweg;
   eingabemodus;
   feldermachen(zweck);
   aufrufen(satz);
   activecontrol:= SuchE;
end
// umschalten auf konfigurieren
else begin
   zweck:= conf;
   felderweg;
   configmodus;
   feldermachen(zweck);
end;

end;

procedure tform1.maskespeichern;
var n : integer;
    endedatei : boolean;
begin
savedialog2.filename:= mfn;
if savedialog2.Execute then begin
  mfn:= savedialog2.filename;
  templb.clear;
  assignfile(f,mfn);
  {$i-}reset(f);{$i+}
  if ioresult = 0 then begin
     endedatei:= eof(f);
     while not endedatei do begin
        endedatei:= eof(f);
        readln(f,s);

        if pos('DATEI',s) > 0 then
           if pos(savetypnamen[savetyp],s) > 0 then
              repeat
                 endedatei:= eof(f);
                 if not endedatei then readln(f,s);
              until (pos('DATEI',s) > 0) or endedatei;
        if not endedatei then tempLB.items.add(s);
     end;
     closefile(f);
  end;
{$i-}rewrite(f);{$i+}
  writeln(f,savetypnamen[savetyp]);
  for n:= 0 to NmaxFelder do begin
     with editarray[n] do begin
       writeln(f,inttostr(n),',',inttostr(left),',',inttostr(top),',',inttostr(width),',',inttostr(height),',',hint,',',maskenfelderlb.items[n]);
     end;
  end;
  for n:= 0 to templb.items.count-1 do
      writeln(f,templb.items[n]);
  closefile(f);
end;
aenderung_maske:= false;
end;


procedure TForm1.Edit1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
const sc_dragmove = $f012;
var
   akt : tmledit;
   aktl : integer;

begin
akt:= sender as tmledit;
aktl:= TWinControl(akt).tag;
ReleaseCapture;
if ssleft in shift then begin
   aenderung_maske:= true;
   if chsize_en then
// Gre ndern
   TWinControl(akt).perform(wm_syscommand,sc_size+5{2}, 0)
// verschieben
   else begin
        TWinControl(akt).perform(wm_syscommand,sc_dragmove, 0);
        if akt.top > grenze then begin
           akt.color:= clgray;
           akt.text:= labelarray[aktl].caption;
           akt.Width := 70;
        end
        else begin
           if (strtoint(akt.hint) and 2) = 2 then
              akt.color:= $0080FFFF else akt.color:= clwindow;
           akt.text:= '';
        end;
   end;
end;
if button = mbRight then begin
  neuessuchfeld(aktl,false);
  aenderung_maske:= true;
end;

// doubleclick -> "mu-Feld"
if doubleclicked then begin
   neuesmussfeld(aktl,false);
   aenderung_maske:= true;
end;
end;

function tform1.neuesmussfeld(mf : integer; machen : boolean) : boolean;
var n,p: integer;
    neu : boolean;

begin
doubleclicked:= false;
ss:= labelarray[mf].caption;
neu:= true;
if not machen then // testen, ob Feld getoggelt werden soll
   for n:= 0 to maxmussfelder do
       if mussfelda[n] = mf then begin
          neu:= false;
          p:= n;
       end;

if editarray[mf].hint <> '' then h:= strtoint(editarray[mf].hint) else h:= 0;
if neu then begin
  h:= h or 2;
  inc(maxmussfelder);
  mussfelda[maxmussfelder]:= mf;
//  ss:= ''+ss;
  labelarray[mf].caption:= ss;
  editarray[mf].color:= $0080FFFF;
end
else begin
  h:= h and not 2;
  editarray[mf].color:= clWindow;
//  labelarray[mf].caption:= copy(ss,2,255);
     for n:= p+1 to maxmussfelder do mussfelda[n-1]:= mussfelda[n];
  dec(maxmussfelder);
end;
editarray[mf].hint:= inttostr(h);
result:= neu;
end; // neuesmussfeld


function tform1.neuessuchfeld(sf : integer; machen : boolean) : boolean;
var neu : boolean;
    n,p,h   : integer;
    ss : string;
begin
neu:= true;
if not machen then // testen, ob Feld getoggelt werden soll
   for n:= 0 to maxsuchfelder do
       if suchfelda[n] = sf then begin
          neu:= false;
          p:= n;
       end;
ss:= editarray[sf].hint;
if ss <> '' then h:= strtoint(ss) else h:= 0;
if neu then begin
  h:= h or 1;
  inc(maxsuchfelder);
  suchfelda[maxsuchfelder]:= sf;
  labelarray[sf].font.color:= clblue;
end
else begin
  h:= h and not 1;
  labelarray[sf].font.color:= clblack;
  for n:= p+1 to maxsuchfelder do
      suchfelda[n-1]:= suchfelda[n];
  dec(maxsuchfelder);
end;
editarray[sf].hint:= inttostr(h);
result:= neu;
end; // neuessuchfeld


procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
chsize_en:= true;
end;

procedure TForm1.Edit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var e : tmledit;
begin
chsize_en:= false;
e:= sender as tmledit;
if foxmail then begin
   if (e.tag = vorname_feld) or (e.tag = nachname_feld) then begin
      if editarray[name_feld].text = '' then auto_name:= true;
      if auto_name then
         editarray[name_feld].text := editarray[nachname_feld].text + ' ' + editarray[vorname_feld].text;
   end;
end;
end;


procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
satz:= updown1.Position;
aufrufen(satz);
end;

procedure TForm1.suchEChange(Sender: TObject);
var m,n: integer;
    suchende,ok : boolean;
    datenfeld,suchtext : string;
begin
//if suche.text = #27 then exit;
suchtext:= uppercase(suchE.text);
ok:= false;
suchende:= false;
if richtung > 0 then begin
   for n:= suchstart to NmaxReihe do begin
     for m:= 0 to maxsuchfelder do begin
       datenfeld:= uppercase(datenSG.cells[suchfelda[m],n]);
       if volltext then begin
          if pos(suchtext,datenfeld) > 0 then ok:= true;
       end
       else if pos(suchtext,datenfeld) = 1 then ok:= true;
     end;
     if ok then break;
   end;
   if n > NmaxReihe then suchende:= true;
end
else begin
   for n:= suchstart downto 0 do begin
     for m:= 0 to maxsuchfelder do begin
       datenfeld:= uppercase(datenSG.cells[suchfelda[m],n]);
       if volltext then begin
          if pos(suchtext,datenfeld) > 0 then ok:= true;
       end else if pos(suchtext,datenfeld) = 1 then ok:= true;
     end;
     if ok then break;
   end;
   if n < 0 then suchende:= true;
end;
satz:= n;
if not suchende then aufrufen(satz)
   else if (suche.text <> '') {and (suche.text <> #27)} then beep;
end;

function Tform1.linksoben : twincontrol;
var n,m : integer;
    min : real;

begin
min:= 100000;
for n:= 0 to Nmaxfelder do
    if editarray[n].top*1000 +editarray[n].left < min then begin
       m:= n;
       min:= editarray[n].top*1000 +editarray[n].left;
    end;
result:= editarray[m];
end;

procedure tform1.neuersatz;
begin
inc(NmaxReihe);
datenSG.RowCount:= NmaxReihe+1;
satz:= NmaxReihe;
neuersatz_flag:= true;
aufrufen(satz);
aenderung:= true;
activecontrol:= linksoben;
end;

procedure tform1.satzloeschen;
var s : string;
    n : integer;

begin
for n:= 0 to 5 do s:= s + editarray[n].text + ' ';
if MessageDlg('Satz: '+s+' wirklich lschen?', mtConfirmation, [mbYes, mbNo], 0) = mrYes
   then begin
//      for n:= 0 to NmaxFelder do
//         datensg.cells[n,satz]:= '';
      for n:= satz to NmaxReihe-1 do begin
        datenSG.rows[n]:= datenSG.rows[n+1];
      end;
      dec(NmaxReihe);
      datenSG.rowcount:= NmaxReihe;
      for n:= 0 to NmaxFelder do
        editarray[n].color:= clgray;
      geloescht:= true;
      aenderung:= true;
   end;
end;

procedure TForm1.suchEKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var gef : boolean;
    altsatz : integer;
    Mgs: TMsg;
begin
altsatz:= satz;
case key of
    vk_prior : begin
                if satz < NmaxReihe then begin
                   repeat
                     inc(satz);
                     gef:= mussfeldtest(satz);
                   until (satz = NmaxReihe) or gef;
                   if gef then aufrufen(satz)
                   else begin
                        satz:= altsatz;
                        beep;
                   end;
                   key:= 0;
                end else beep;
              end;
    vk_down : begin
                if satz < NmaxReihe then begin
                   suchstart:= satz+1;
                   richtung:= 1;
                   suchechange(sender);
                   key:= 0;
                end;
              end;
    vk_next: begin
                if satz > 0 then begin
                   repeat
                     dec(satz);
                     gef:= mussfeldtest(satz);
                   until (satz = 0) or gef;
                   if gef then aufrufen(satz)
                   else begin
                        satz:= altsatz;
                        beep;
                   end;

                   key:= 0;
                end else beep;
              end;
    vk_up   : begin
                if satz > 0 then begin
                   suchstart:= satz-1;
                   richtung:= -1;
                   suchechange(sender);
                   key:= 0;
                end;
              end;
    vk_delete  : if ssctrl in shift then satzloeschen;
    vk_insert  : if ssctrl in shift then neuersatz;
    vk_escape  : begin
                    PeekMessage(Mgs, 0, WM_CHAR, WM_CHAR, PM_REMOVE);
                    exit1Click(sender);
                 end;

    else begin
                suchstart:= 0;
                richtung:= 1;
    end;
end;
end;

procedure TForm1.suchEEnter(Sender: TObject);
begin
suchstart:= 0;
richtung:= 1;
end;

procedure TForm1.Edit1Change(Sender: TObject);
var akt : tmledit;
    n : integer;
begin
akt:= sender as tmledit;
n:= akt.Tag;
if akt.Top <= grenze then begin
   datenSG.cells[n,satz]:= akt.text;
end;
end;


procedure TForm1.Edit1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var akt : tmledit;
begin
h:= raster div 2;
akt:= sender as tmledit;
akt.top:= ((akt.top+h) div raster)*raster;
akt.left:= ((akt.left+h) div raster)*raster;
akt.height:= ((akt.height+h) div raster)*raster;
labelarray[akt.Tag].top:= akt.top - 15;
labelarray[akt.tag].left:= akt.left;
end;


procedure TForm1.ausgeben1Click(Sender: TObject);
var m :  TMenuItem;
    pa : string;
begin
{with Sender as TMenuItem do begin
    ShowMessage(Caption);
  end;}
m:= sender as TMenuItem;
s:= m.Caption;
pa:= fn+' '+inttostr(m.tag);
shellexecute(form1.handle,'open','csvextract.exe',pchar(pa),pchar(startdir),SW_SHOWNORMAL);
end;

procedure TForm1.DatenSGClick(Sender: TObject);
begin
//label1.caption:= datensg.Cells[datensg.col,DATEnsg.row]     ;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
var e : tmlEdit;
begin
e:= sender as tmlEdit;
//Eingabetaste nur fr mehrzeilige Felder erlauben!
case key of
 #13 : begin
            if e.height < e.Font.size *4 then begin
               key:= #0;
               beep;
            end;
       end;
 '"' : begin
            beep;
            key:= #0;
       end;
end; {case}
aenderung:= true;
end;


procedure TForm1.Edit1DblClick(Sender: TObject);
begin
doubleclicked:= true;
end;

procedure TForm1.BMaskeClick(Sender: TObject);
var e: array[savetype] of tmenuitem;
    typ: savetype;
    popUpMenu2 : tpopupmenu;

    function isoliere(s : string) : string;
          begin
          s:= copy(s,pos('=',s)+1,255);
          while (s<>'')and (s[1] = ' ') do delete(s,1,1);
          while (s<>'')and (s[length(s)] = ' ') do delete(s,length(s),1);
          result:= s;
          end;

begin
if aenderung_maske or aenderung then begin
   if zweck = conf then begin
      if Messagedlgpos('Maske erst speichern?',mtInformation,[mbyes,mbno], 0,form1.left+bmaske.Left ,80) = mryes then
         maskespeichern;
      aenderung_maske:= false;
   end
   else begin
      if Messagedlgpos('nderungen erst speichern?',mtInformation,[mbyes,mbno], 0,form1.left+bmaske.Left ,80) = mryes then
         speichern1click(sender);
      aenderung:= false;
   end
end
else begin
    popUpMenu2:= tpopupmenu.Create(self);
    for typ:= adresstype to alletype do begin
      e[typ]:= tmenuitem.create(self);
      e[typ].Caption := savetypnamen[typ];
      e[typ].OnClick:= Maske1click;
      e[typ].tag:= integer(typ);
      popupmenu2.Items.Add(e[typ]);
    end;
    popupmenu2.Popup(form1.left+bmaske.left-10,form1.top+50);
end;
end; // Maskeclick

procedure TForm1.Maske1Click(Sender: TObject);
var m :  TMenuItem;

begin
m:= sender as TMenuItem;
s:= m.Caption;
savetyp:= savetype(m.tag);
felderweg;
feldermachen(zweck);
if zweck = edit then activecontrol:= SuchE;
end;

procedure tform1.SortStringGrid(var GenStrGrid: TStringGrid; ThatCol: Integer);
const
  TheSeparator = '';
var
  CountItem, I, J, K, ThePosition: integer;
  MyList: TStringList;
  tempSG : tstringgrid;
  MyString, TempString: string;

begin
// Give the number of rows in the StringGrid
CountItem := GenStrGrid.RowCount;
//Create the List
MyList:= TStringList.Create;
tempSG:= tstringgrid.Create(form1);
tempSG.rowcount:= genstrgrid.RowCount; tempsg.ColCount:= genstrgrid.ColCount;
MyList.Sorted := False;
try
  begin
    for I := 0 to (CountItem - 1) do
      MyList.Add(GenStrGrid.Rows[I].Strings[ThatCol] + TheSeparator + inttostr(i));

    Mylist.Sort;

    for K := 1 to Mylist.Count do
    begin
      //Take the String of the line (K  1)
      MyString := MyList.Strings[(K - 1)];
      //Find the position of the Separator in the String
      ThePosition := Pos(TheSeparator, MyString);
      TempString  := '';
      {Eliminate the Text of the column on which we have sorted the StringGrid}
      TempString := Copy(MyString, (ThePosition + 1), Length(MyString));
      MyList.Strings[(K - 1)] := '';
      MyList.Strings[(K - 1)] := TempString;
    end;

    for J := 0 to (CountItem -1) do
      tempSG.Rows[J] := genstrgrid.rows[strtoint(mylist.strings[j])];

    // Refill the StringGrid
    for J := 0 to (CountItem -1) do
      GenStrGrid.Rows[J] := tempSG.Rows[J];
  end;
finally
  MyList.Free;
  tempSG.free;
end;
end; //SortStringGrid

procedure tform1.neuessortierfeld(feld : tmledit);
var x,akt : integer;
begin
if assigned(sortierfeld) then begin
   akt:= sortierfeld.tag;
   labelarray[akt].font.style:= [];
   x:= strtoint(sortierfeld.hint);
   x:= x and not 4;
   sortierfeld.hint:= inttostr(x);
end;
sortierfeld:= feld;
x:= strtoint(sortierfeld.hint);
x:= x or 4;
sortierfeld.hint:= inttostr(x);
akt:= sortierfeld.tag;
labelarray[akt].font.style:= [fsbold];
end;

procedure TForm1.BSortierFeldClick(Sender: TObject);
var popupmenu2 : tpopupmenu;
    n : integer;
    e : tmenuitem;
begin
popUpMenu2:= tpopupmenu.Create(self);
for n:= 0 to nmaxfelder do begin
    e:= tmenuitem.create(self);
    e.Caption := labelarray[n].caption;
    e.OnClick:= BsortClick;
    e.tag:= integer(n);
    popupmenu2.Items.Add(e);

end;
popupmenu2.Popup(form1.left+Bsortierfeld.left-10,form1.top+50);
end;

procedure TForm1.BsortClick(Sender: TObject);
var e : tmenuitem;
begin
e:= sender as tmenuitem;
neuessortierfeld(editarray[e.tag]);
sortstringgrid(datenSG,sortierfeld.tag);
end;

procedure TForm1.BAusgabeDateiClick(Sender: TObject);
var
//   popupmenu2 : tpopupmenu;
   typ        : savetype;
//   e          : tmenuitem;

begin
for typ:= adresstype to foxmailtype do begin
    n:= integer(typ);
    ausdatSG.cells[0,n] := savetypnamen[typ];
    ausgabedateiSG.cells[0,n] := savenamen[typ];
end;
ausdatSG.cells[0,n+1] := 'Originaldatei';
ausgabedateiSG.cells[0,n+1] := savedialog1.FileName;
panel2.visible:= true;
panel2.bringtofront;
end;

procedure TForm1.PopupMenu2Popup(Sender: TObject);
var st : savetype;
    e : tmenuitem;
begin
e:= sender as tmenuitem;
if e.tag > integer(foxmailtype) then begin
  s:= 'Ausgabe-Datei fr Originaldatei festlegen';
  SpeicherOrtDialog.Title:= s;
  SpeicherOrtDialog.InitialDir := savedialog1.InitialDir;
  SpeicherOrtDialog.FileName := savedialog1.filename;
  if SpeicherOrtDialog.Execute then begin
     s:= speicherortDialog.filename;
     savedialog1.filename:= s;
  end;
end
else begin
  st:= savetype(e.tag);
  s:= 'Ausgabe-Datei fr '+savetypnamen[st]+' festlegen';
  SpeicherOrtDialog.Title:= s;
  SpeicherOrtDialog.InitialDir :=ExtractFilePath(savenamen[st]);
  SpeicherOrtDialog.FileName := savenamen[st];
  if SpeicherOrtDialog.Execute then begin
     s:= speicherortDialog.filename;
     savenamen[st]:= copy(s,1,length(s)-4);
  end;
end;
end;

procedure TForm1.BeinsortierenClick(Sender: TObject);
begin
sortstringgrid(datenSG,sortierfeld.tag);
beinsortieren.visible:= false;
lneuersatz.visible:= false;
end;

procedure TForm1.Label1Click(Sender: TObject);

begin
aktlabel:= sender as tlabel;
  with EFeldName do begin
     left:= aktlabel.left;
     top:= aktlabel.top+18;
     visible:= true;
     text:= aktlabel.caption;
     bringtofront;
  end;
end;

procedure TForm1.EFeldNameKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
//    akt : tlabel;
    i   : integer;
begin
i:= aktlabel.tag;
case key of
   vk_return : begin
                  eFeldName.visible:= false;
                  maskenfelderLB.items[i]:= eFeldname.text;
                  labelarray[i].caption:= eFeldname.text;
                  aenderung_maske:= true;
               end;
end;
end;

procedure TForm1.BAusDatOkClick(Sender: TObject);
var st : savetype;
begin
savedialog1.filename:= AusgabeDateiSG.cells[0,integer(foxmailtype)+1];
for st:= adresstype to foxmailtype do
    savenamen[st]:= AusgabeDateiSG.cells[0,integer(st)];
panel2.visible:= false;
end;

procedure TForm1.AusgabeDateiSGDblClick(Sender: TObject);
var x,y : integer;
    st : savetype;
begin
x:= ausgabedateiSG.col;
y:= ausgabedateiSG.row;
if x = 0 then begin
  if y > integer(foxmailtype) then begin
    s:= 'Ausgabe-Datei fr Originaldatei festlegen';
    SpeicherOrtDialog.Title:= s;
    SpeicherOrtDialog.InitialDir := savedialog1.InitialDir;
    SpeicherOrtDialog.FileName := savedialog1.filename;
    if SpeicherOrtDialog.Execute then begin
       s:= speicherortDialog.filename;
       AusgabeDateiSG.cells[x,y]:= s;
    end;
  end
  else begin
    st:= savetype(y);
    s:= 'Ausgabe-Datei fr '+savetypnamen[st]+' festlegen';
    SpeicherOrtDialog.Title:= s;
    SpeicherOrtDialog.InitialDir :=ExtractFilePath(savenamen[st]);
    SpeicherOrtDialog.FileName := savenamen[st];
    if SpeicherOrtDialog.Execute then begin
       s:= speicherortDialog.filename;
       AusgabeDateiSG.cells[x,y]:= s;
    end;
  end;
end;
end;

procedure TForm1.BAusDatescClick(Sender: TObject);
begin
panel2.visible:= false;
end;

procedure TForm1.AusDatSSGClick(Sender: TObject);
var x,y : integer;
begin
//x:= ausdatSsg.col;
y:= ausdatSsg.row;
if ausdatSsg.cells[0,y] <> 'x' then begin
   ausdatSsg.cells[0,y]:= 'x';
end
else begin
   ausdatSsg.cells[0,y] := '';
end;
end;

procedure TForm1.AusDatLsgClick(Sender: TObject);
var x,y : integer;
begin
x:= ausdatLsg.col;
y:= ausdatLsg.row;
if ausdatLsg.cells[x,y] = '' then begin
   ausdatLsg.cells[x,y]:= 'x';
end
else begin
   ausdatLsg.cells[x,y] := '';
end;
end;

procedure TForm1.write_foxmail_addressbook(Sender: TObject);
const
   ind_head : string = #$5a#$58#$4c#$00#$07#$d0#$00#$00#$00#$BC#$7F#$54#$48#$f1#$53#$26+
                       #$41#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00+
                       #$00#$00#$00#$00#$00#$00#$00#$40#$00#$00#$00#$00#$00#$00#$00#$00+
                       #$00#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00#$00;
   ind_s1   : string = #$ff#$ff#$ff#$ff;
var
   f_ind : charfiletype;
   f_box : textfile;
   l_first,l_last,l_mail,l_i_mail,l_name,nn,n     : integer;
   offset     : longint;
   boxname,indname,pfad,name,first,last,i_mail,mail,offset_s : string;
   dat : array[0..$b0] of char;

   procedure writedat;
   var n : integer;
   begin
   for n:= 0 to $af do write(f_ind,dat[n]);
   end;

   procedure setze(p : integer; s : string);
   var n : integer;
   begin
   for n:= 1 to length(s) do dat[p+n-1]:= s[n];
   end;

begin
boxname:= savenamen[foxmailtype];
//pfad:= extractfilepath(boxname);
assignfile(f_box,boxname);
rewrite(f_box);
//
indname:= ChangeFileExt(boxname,'.ind');
assignfile(f_ind,indname);
rewrite(f_ind);
s:= ExtractFileName(indname);
s:= uppercase(copy(s,1,length(s)-4));
if s <> 'ADDRESS' then
  for n:= 1 to length(s) do ind_head[$12+n]:= s[n];
writestr(f_ind,ind_head);
offset:= $10;

for n:= 0 to nMaxreihe do begin
  mail:= datenSG.cells[email_feld,n];
  if mail <> '' then begin
    first:= datenSG.cells[vorname_feld,n];
    last:= datenSG.cells[nachname_feld,n];
    name:= last+' '+first;
{    if name = ' ' then begin
       name:= datenSG.cells[name_feld,n];
       last:= name;
    end;}
//    while name[1] = ' ' do delete(name,1,1);
    l_name:= length(name);
    if pos(',',mail) > 0 then begin
       s:= '';
       p:= pos(',',mail);
       i_mail:= copy(mail,1,p-1);
       while p > 0 do begin
          s:= s + copy(mail,1,p-1) + #$0d#$0a + ' ';
          delete(mail,1,p);
          p:= pos(',',mail);
       end;
       mail:= s+mail;
    end else i_mail:= mail;
    l_mail:= length(mail);
    l_i_mail:= length(i_mail);
    writeln(f_box,#$10#$10#$10#$10#$10#$10#$10#$11#$11#$11#$11#$11#$11+'S');
    writeln(f_box,'Emails: '+mail);
    writeln(f_box,'FirstName: '+first);
    writeln(f_box,'LastName: '+last);
    writeln(f_box);

    for nn:= 1 to $b0 do dat[nn]:= #0;
    setze(0,chr((n+1) mod 256) + chr((n+1) div 256));
    offset_s:= chr(offset mod 256) + chr(offset div 256);
    setze(5,offset_s);
    setze($9,chr(l_mail+l_name+$24));    // Lnge des Satzes in .box
    setze($d,ind_s1);
    setze($12,chr(l_name));
    setze($13,name);
    setze($47,#$42#$01#$74#$fa#$97#$00#$43#$28#$40);
    setze($33,chr(l_i_mail));
    setze($34,i_mail);
//    setze($5B,#$42#$01#$74#$fa#$97#$00#$43#$28#$40);
    setze($68,#$01#$ba#$51#$41);
    setze($78,#1+'}NA');
    writedat;
    inc(offset,l_name+l_mail+$34);
  end;
end;
closefile(f_box);
closefile(f_ind);
end;

end.
